from AccessControl import ClassSecurityInfo
from config import ManageProperties
from Globals import InitializeClass
from OFS.PropertyManager import PropertyManager
from OFS.SimpleItem import SimpleItem
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.utils import UniqueObject
from Products.CMFPlone.interfaces.NonStructuralFolder import INonStructuralFolder
import os

class TramlineTool(UniqueObject, SimpleItem, PropertyManager):
    id = 'portal_tramline'
    meta_type = 'Tramline Tool'

    __implements__ = (INonStructuralFolder,)

    manage_options = (PropertyManager.manage_options)

    _properties = PropertyManager._properties + (
        {'id':'tramlinepath', 'type':'string', 'mode':'w',
         'label':'Path to tramline data directory',},
        )

    tramlinepath = ""

    security = ClassSecurityInfo()

    def getTramlinePath(self):
        return self.getProperty('tramlinepath')

    def removeFile(self, obj):
        if not obj.is_tramlined:
            return
        path = os.path.join(self.getTramlinePath(),
                            'repository',
                            str(obj))
        os.remove(path)
        
        
InitializeClass(TramlineTool)
