from AccessControl import ClassSecurityInfo
from Products.Archetypes.Widget import FileWidget
from Products.Archetypes.Registry import registerWidget

class TramlineWidget(FileWidget):
    _properties = FileWidget._properties.copy()
    _properties.update({'macro':'widget_tramline'})

    security = ClassSecurityInfo()

    def process_form(self, instance, field, form, empty_marker=None,
                     emptyReturnsMarker=False):
        """Overriden to set Tramline header."""
        value = FileWidget.process_form(self, instance, field,
                                              form, empty_marker,
                                              emptyReturnsMarker)
        if not value: return None
        try:
            form.get('tramline_enable', []).index(field.getName())
            tramline_enabled = True
        except ValueError:
            tramline_enabled = False
        if tramline_enabled:
            instance.REQUEST.RESPONSE.setHeader('tramline_ok','')
        return (value[0], tramline_enabled), value[1]
    
registerWidget(TramlineWidget,
               title='Tramline widget',
               description=('This widget sets all appropriate headers for use '
                            'with Tramline.'),
               used_for=('Products.Achetypes.Field.FileField',)
               )


